Package org.apache.datasketches.theta

# Class AnotB

java.lang.Object
org.apache.datasketches.theta.SetOperation
org.apache.datasketches.theta.AnotB

All Implemented Interfaces:
  `MemoryStatus`

public abstract class AnotB extends SetOperation
Computes a set difference, A-AND-NOT-B, of two theta sketches. This class includes both stateful and stateless operations.

The stateful operation is as follows:

     AnotB anotb = SetOperationBuilder.buildAnotB();

     anotb.setA(Sketch skA); //The first argument.
     anotb.notB(Sketch skB); //The second (subtraction) argument.
     anotb.notB(Sketch skC); // ...any number of additional subtractions...
     anotb.getResult(false); //Get an interim result.
     anotb.notB(Sketch skD); //Additional subtractions.
     anotb.getResult(true);  //Final result and resets the AnotB operator.

The stateless operation is as follows:

     AnotB anotb = SetOperationBuilder.buildAnotB();

     CompactSketch csk = anotb.aNotB(Sketch skA, Sketch skB);

Calling the setA operation a second time essentially clears the internal state and loads the new sketch.

The stateless and stateful operations are independent of each other with the exception of sharing the same update hash seed loaded as the default seed or specified by the user as an argument to the builder.

Author:
  Lee Rhodes

## Constructor Summary

Constructors
Constructor
Description
`AnotB()`

## Method Summary

Modifier and Type
Method
Description
`CompactSketch`
`aNotB(Sketch skA, Sketch skB)`
Perform A-and-not-B set operation on the two given sketches and return the result as an ordered CompactSketch on the heap.
`abstract CompactSketch`
`aNotB(Sketch skA, Sketch skB, boolean dstOrdered, org.apache.datasketches.memory.WritableMemory dstMem)`
Perform A-and-not-B set operation on the two given sketches and return the result as a CompactSketch.
`Family`
`getFamily()`
Gets the Family of this SetOperation
`abstract CompactSketch`
`getResult(boolean reset)`
Gets the result of the multistep, stateful operation AnotB that have been executed with calls to `setA(Sketch)` and (`notB(Sketch)` or `notB(org.apache.datasketches.theta.Sketch)`).
`abstract CompactSketch`
`getResult(boolean dstOrdered, org.apache.datasketches.memory.WritableMemory dstMem, boolean reset)`
Gets the result of the multistep, stateful operation AnotB that have been executed with calls to `setA(Sketch)` and (`notB(Sketch)` or `notB(org.apache.datasketches.theta.Sketch)`).
`abstract void`
`notB(Sketch skB)`
This is part of a multistep, stateful AnotB operation and sets the given Theta sketch as the second (or n+1th) argument B of A-AND-NOT-B.
`abstract void`
`setA(Sketch skA)`
This is part of a multistep, stateful AnotB operation and sets the given Theta sketch as the first argument A of A-AND-NOT-B.

### Methods inherited from class org.apache.datasketches.theta.SetOperation

`builder, getMaxAnotBResultBytes, getMaxIntersectionBytes, getMaxUnionBytes, heapify, heapify, wrap, wrap, wrap, wrap`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.datasketches.common.MemoryStatus

`hasMemory, isDirect, isSameResource`

## Constructor Details

### AnotB

public AnotB()

## Method Details

### getFamily

public Family getFamily()
Description copied from class: `SetOperation`
Gets the Family of this SetOperation

Specified by:
  `getFamily` in class `SetOperation`
Returns:
  the Family of this SetOperation

### setA

public abstract void setA(Sketch skA)
This is part of a multistep, stateful AnotB operation and sets the given Theta sketch as the first argument A of A-AND-NOT-B. This overwrites the internal state of this AnotB operator with the contents of the given sketch. This sets the stage for multiple following notB steps.

An input argument of null will throw an exception.

Rationale: In mathematics a "null set" is a set with no members, which we call an empty set. That is distinctly different from the java null, which represents a nonexistent object. In most cases it is a programming error due to some object that was not properly initialized. With a null as the first argument, we cannot know what the user's intent is. Since it is very likely that a null is a programming error, we throw a an exception.

An empty input argument will set the internal state to empty.

Rationale: An empty set is a mathematically legal concept. Although it makes any subsequent, valid argument for B irrelevant, we must allow this and assume the user knows what they are doing.

Performing `getResult(boolean)` just after this step will return a compact form of the given argument.

Parameters:
  `skA` - The incoming sketch for the first argument, A.

### notB

public abstract void notB(Sketch skB)
This is part of a multistep, stateful AnotB operation and sets the given Theta sketch as the second (or n+1th) argument B of A-AND-NOT-B. Performs an AND NOT operation with the existing internal state of this AnotB operator.

An input argument of null or empty is ignored.

Rationale: A null for the second or following arguments is more tolerable because A NOT null is still A even if we don't know exactly what the null represents. It clearly does not have any content that overlaps with A. Also, because this can be part of a multistep operation with multiple notB steps. Other following steps can still produce a valid result.

Use `getResult(boolean)` to obtain the result.

Parameters:
  `skB` - The incoming Theta sketch for the second (or following) argument B.

### getResult

public abstract CompactSketch getResult(boolean reset)
Gets the result of the multistep, stateful operation AnotB that have been executed with calls to `setA(Sketch)` and (`notB(Sketch)` or `notB(org.apache.datasketches.theta.Sketch)`).

Parameters:
  `reset` - If true, clears this operator to the empty state after this result is returned. Set this to false if you wish to obtain an intermediate result.
Returns:
  the result of this operation as an ordered, on-heap `CompactSketch`.

### getResult

public abstract CompactSketch getResult(boolean dstOrdered, org.apache.datasketches.memory.WritableMemory dstMem, boolean reset)
Gets the result of the multistep, stateful operation AnotB that have been executed with calls to `setA(Sketch)` and (`notB(Sketch)` or `notB(org.apache.datasketches.theta.Sketch)`).

Parameters:
  `dstOrdered` - If true, the result will be an ordered `CompactSketch`. See Destination Ordered.
  `dstMem` - if not null the given Memory will be the target location of the result. See Destination Memory.
  `reset` - If true, clears this operator to the empty state after this result is returned. Set this to false if you wish to obtain an intermediate result.
Returns:
  the result of this operation as a `CompactSketch` in the given dstMem.

### aNotB

public CompactSketch aNotB(Sketch skA, Sketch skB)
Perform A-and-not-B set operation on the two given sketches and return the result as an ordered CompactSketch on the heap.

This a stateless operation and has no impact on the internal state of this operator. Thus, this is not an accumulating update and does not interact with the `setA(Sketch)`, `notB(Sketch)`, `getResult(boolean)`, or `getResult(boolean, WritableMemory, boolean)` methods.

If either argument is null an exception is thrown.

Rationale: In mathematics a "null set" is a set with no members, which we call an empty set. That is distinctly different from the java null, which represents a nonexistent object. In most cases null is a programming error due to a non-initialized object.

With a null as the first argument we cannot know what the user's intent is and throw an exception. With a null as the second argument for this method we must return a result and there is no following possible viable arguments for the second argument so we thrown an exception.

Parameters:
  `skA` - The incoming sketch for the first argument. It must not be null.
  `skB` - The incoming sketch for the second argument. It must not be null.
Returns:
  an ordered CompactSketch on the heap

### aNotB

public abstract CompactSketch aNotB(Sketch skA, Sketch skB, boolean dstOrdered, org.apache.datasketches.memory.WritableMemory dstMem)
Perform A-and-not-B set operation on the two given sketches and return the result as a CompactSketch.

This a stateless operation and has no impact on the internal state of this operator. Thus, this is not an accumulating update and does not interact with the `setA(Sketch)`, `notB(Sketch)`, `getResult(boolean)`, or `getResult(boolean, WritableMemory, boolean)` methods.

If either argument is null an exception is thrown.

Rationale: In mathematics a "null set" is a set with no members, which we call an empty set. That is distinctly different from the java null, which represents a nonexistent object. In most cases null is a programming error due to a non-initialized object.

With a null as the first argument we cannot know what the user's intent is and throw an exception. With a null as the second argument for this method we must return a result and there is no following possible viable arguments for the second argument so we thrown an exception.

Parameters:
  `skA` - The incoming sketch for the first argument. It must not be null.
  `skB` - The incoming sketch for the second argument. It must not be null.
  `dstOrdered` - See Destination Ordered.
  `dstMem` - See Destination Memory.
Returns:
  the result as a CompactSketch.